#!/usr/bin/python
# -*- coding: Utf-8 -*-

from PyQt4.QtCore import *
from PyQt4.QtGui import *

class Label(QLabel):
	"""Chaîne de caractères ayant un comportement hyper-texte"""
	def __init__(self, parent, texte, idItem):
		QLabel.__init__(self)
		self.parent = parent
		self.idItem = idItem
		self.setText("<font color='blue'><center>%s</center></font>" %texte)
		# le pointeur de la souris change au survol du label
		self.setCursor(Qt.PointingHandCursor)
	
	def mousePressEvent(self, event):
		"""Un clic sur le label entraîne l'ouverture du cadre associé"""
		if self.idItem=="video_seul":	# Montage video : video seul
			self.parent.treeWidgetAnimation.setCurrentItem(self.parent.itemTree_SVideo)
			self.parent.stacked_onglet_animation.setCurrentIndex(self.parent.stacked_animation_MontagVideoVidSeul)
		elif self.idItem=="video&audio":	# Montage video : video + audio
			self.parent.treeWidgetAnimation.setCurrentItem(self.parent.itemTree_SVideoAudio)
			self.parent.stacked_onglet_animation.setCurrentIndex(self.parent.stacked_animation_MontagVideoVidPlusAudio)
		elif self.idItem=="decouper_video":	# Montage video : decouper une video
			self.parent.treeWidgetAnimation.setCurrentItem(self.parent.itemTree_SDecouperVideo)
			self.parent.stacked_onglet_animation.setCurrentIndex(self.parent.stacked_animation_MontagVideoDecoupUneVideo)


class Animation_MontagVideo(QWidget):
	# -----------------------------------------
	# Cadre accueillant les widgets de :
	# Animation >> Montage vidéo
	# -----------------------------------------
	def __init__(self, parent):
        	QWidget.__init__(self)
		
		# Boite d'alignement vertical
		vbox=QVBoxLayout(self)
		
		# Titre de la page
		txt = _(u"Montage Vidéo:")
		titre_du_cadre=QLabel("<H2><center><u>%s</u></center></H2>" %txt)
		
		# Lien vers les sous-cadres
		labelVideoSeul = Label(parent, _(u"Montage: Vidéo Seul"), "video_seul")
		labelVideoAudio = Label(parent, _(u"Montage: Vidéo et Audio"), "video&audio")
		labelDecouperVideo = Label(parent, _(u"Montage: Découper une Vidéo"), "decouper_video")
		
		# Ajout du titre de la page a la boite verticale
		vbox.addWidget(titre_du_cadre)
		vbox.addSpacing(10)
		vbox.addWidget(labelVideoSeul)
		vbox.addWidget(labelVideoAudio)
		vbox.addWidget(labelDecouperVideo)
		
		vbox.addStretch()