#!/usr/bin/python
# -*- coding: Utf-8 -*-

from PyQt4.QtCore import *
from PyQt4.QtGui import *


class Label(QLabel):
	"""Chaîne de caractères ayant un comportement hyper-texte"""
	def __init__(self, parent, texte, idItem):
		QLabel.__init__(self)
		self.parent = parent
		self.idItem = idItem
		self.setText("<font color='blue'><center>%s</center></font>" %texte)
		# le pointeur de la souris change au survol du label
		self.setCursor(Qt.PointingHandCursor)
	
	def mousePressEvent(self, event):
		"""Un clic sur le label entraîne l'ouverture du cadre associé"""
		if self.idItem=="pl_contact":	# Image divers -- planche-contact
			self.parent.treeWidgetDiversImage.setCurrentItem(self.parent.itemTree_PlContact)
			self.parent.stacked_onglet_image.setCurrentIndex(self.parent.stacked_image_divers_PlContact)
		elif self.idItem=="information":   # Image divers -- information
			self.parent.treeWidgetDiversImage.setCurrentItem(self.parent.itemTree_Information)
			self.parent.stacked_onglet_image.setCurrentIndex(self.parent.stacked_image_divers_Information)
		elif self.idItem=="changer_format":	# Image divers -- changer format
			self.parent.treeWidgetDiversImage.setCurrentItem(self.parent.itemTree_ChangFormat)
			self.parent.stacked_onglet_image.setCurrentIndex(self.parent.stacked_image_divers_ChangFormat)
		elif self.idItem=="redimensionner":	# Image divers -- redimensionner
			self.parent.treeWidgetDiversImage.setCurrentItem(self.parent.itemTree_Redimens)
			self.parent.stacked_onglet_image.setCurrentIndex(self.parent.stacked_image_divers_Redimens)
		elif self.idItem=="txt_sur_img":	# Image divers -- texte sur image
			self.parent.treeWidgetDiversImage.setCurrentItem(self.parent.itemTree_TxtSurImg)
			self.parent.stacked_onglet_image.setCurrentIndex(self.parent.stacked_image_divers_TxtSurImg)
		elif self.idItem=="img_composite":	# Image divers -- image composite
			self.parent.treeWidgetDiversImage.setCurrentItem(self.parent.itemTree_ImgComposit)
			self.parent.stacked_onglet_image.setCurrentIndex(self.parent.stacked_image_divers_Compositing)
		elif self.idItem=="renommer_img":	# Image divers -- renommer images
			self.parent.treeWidgetDiversImage.setCurrentItem(self.parent.itemTree_RenomImg)
			self.parent.stacked_onglet_image.setCurrentIndex(self.parent.stacked_image_divers_RenomImg)
		elif self.idItem=="pour_le_web":	# Image divers -- pour le web
			self.parent.treeWidgetDiversImage.setCurrentItem(self.parent.itemTree_PourLeWeb)
			self.parent.stacked_onglet_image.setCurrentIndex(self.parent.stacked_image_divers_PourLeWeb)


class Image_Divers(QWidget):
	# -----------------------------------------
	# Cadre accueillant les widgets de :
	# Image >> Divers
	# -----------------------------------------
	def __init__(self, parent):
        	QWidget.__init__(self)
		
		# Boite d'alignement vertical
		vbox=QVBoxLayout(self)
		
		# Titre de la page
		txt = _(u"Image Divers:")
		titre_du_cadre=QLabel("<H2><center><u>%s</u></center></H2>" %txt)
		
		# Lien vers les sous-cadres
		labelPlancheContact = Label(parent, _(u"Planche contact"), "pl_contact")
		labelInformation = Label(parent, _(u"Information"), "information")
		labelChangerFormat = Label(parent, _(u"Changer format"), "changer_format")
		labelRedimensionner = Label(parent, _(u"Redimensionner"), "redimensionner")
		labelTxtSurImg = Label(parent, _(u"Texte sur images"), "txt_sur_img")
		labelImageComposite = Label(parent, _(u"Image composite"), "img_composite")
		labelRenommerImg = Label(parent, _(u"Renommer images"), "renommer_img")
		labelPourLeWeb = Label(parent, _(u"Pour le web"), "pour_le_web")
		
		# Ajout du titre de la page a la boite verticale
		vbox.addWidget(titre_du_cadre)
		vbox.addSpacing(10)
		vbox.addWidget(labelPlancheContact)
		vbox.addWidget(labelInformation)
		vbox.addWidget(labelChangerFormat)
		vbox.addWidget(labelRedimensionner)
		vbox.addWidget(labelTxtSurImg)
		vbox.addWidget(labelImageComposite)
		vbox.addWidget(labelRenommerImg)
		vbox.addWidget(labelPourLeWeb)
		
		vbox.addStretch()