#!/usr/bin/python
# -*- coding: Utf-8 -*-

import os
from PyQt4.QtCore import *
import ConfigParser # pour relever les erreurs

class Base(object):
	#-------------------------------------
	# Fonctions communes au module Image
	#-------------------------------------

	def getRepSource(self, listeEntree, config):
		"Renvoie le répertoire source qui sera utilisée dans la boite de dialogue de fichiers"
		
		if isinstance(listeEntree, list):
			if listeEntree!=[] and os.path.exists(os.path.dirname(listeEntree[0])):
				repEntree = os.path.dirname(listeEntree[0])
			else:
				try:
					repEntree = config.get('Image','path')
				except ConfigParser.NoOptionError, e:
					repEntree = '~'
				if not os.path.exists(repEntree):
					repEntree = '~'
		
		elif isinstance(listeEntree, str):
			if listeEntree!='' and os.path.exists(os.path.dirname(listeEntree)):
				repEntree = os.path.dirname(listeEntree)
			else:
				try:
					repEntree = config.get('Image','path')
				except ConfigParser.NoOptionError, e:
					repEntree = '~'
				if not os.path.exists(repEntree):
					repEntree = '~'
		
		return os.path.expanduser(repEntree)
	
	
	def setRepSource(self, listeEntree, config):
		"Sauvegarde le répertoire source qui sera utilisée dans la boite de dialogue de fichiers"
		if isinstance(listeEntree, list):
			if len(listeEntree)==0: return
			config.set('Image','path',os.path.dirname(str(listeEntree[0])))
		
		elif isinstance(listeEntree, str):
			if listeEntree=='': return
			config.set('Image','path',os.path.dirname(listeEntree))