#!/usr/bin/python
# -*- coding: Utf-8 -*-

from PyQt4.QtCore import *
from PyQt4.QtGui import *


class Label(QLabel):
	"""Chaîne de caractères ayant un comportement hyper-texte"""
	def __init__(self, parent, texte, idItem):
		QLabel.__init__(self)
		self.parent = parent
		self.idItem = idItem
		self.setText("<font color='blue'><center>%s</center></font>" %texte)
		# le pointeur de la souris change au survol du label
		self.setCursor(Qt.PointingHandCursor)
	
	def mousePressEvent(self, event):
		"""Un clic sur le label entraîne l'ouverture du cadre associé"""
		if self.idItem=="fondu_enchaine":	# Image transitions -- fondu enchaîné
			self.parent.treeWidgetDiversImage.setCurrentItem(self.parent.itemTree_FonduEnchaine)
			self.parent.stacked_onglet_image.setCurrentIndex(self.parent.stacked_image_transitions_fondEnch)
		elif self.idItem=="spirale":   # Image transitions -- spirale
			self.parent.treeWidgetDiversImage.setCurrentItem(self.parent.itemTree_Spirale)
			self.parent.stacked_onglet_image.setCurrentIndex(self.parent.stacked_image_transitions_Spirale)


class Image_Transitions(QWidget):
	# -----------------------------------------
	# Cadre accueillant les widgets de :
	# Image >> Transitions
	# -----------------------------------------
	def __init__(self, parent):
        	QWidget.__init__(self)
		
		# Boite d'alignement vertical
		vbox=QVBoxLayout(self)
		
		# Titre de la page
		txt = _(u"Image Transitions:")
		titre_du_cadre=QLabel("<H2><center><u>%s</u></center></H2>" %txt)
		
		# Lien vers les sous-cadres
		labelFonduEnchaine = Label(parent, _(u"Fondu enchaîné"), "fondu_enchaine")
		labelSpirale = Label(parent, _(u"Spirale"), "spirale")
		
		# Ajout du titre de la page a la boite verticale
		vbox.addWidget(titre_du_cadre)
		vbox.addSpacing(10)
		vbox.addWidget(labelFonduEnchaine)
		vbox.addWidget(labelSpirale)
		
		vbox.addStretch()